Version:  2.0.40 2.2.26 2.4.37 3.13 3.14 3.15 3.16 3.17 3.18 3.19 4.0 4.1 4.2 4.3 4.4 4.5 4.6 4.7 4.8 4.9 4.10

Linux/scripts/extract-ikconfig

  1 #!/bin/sh
  2 # ----------------------------------------------------------------------
  3 # extract-ikconfig - Extract the .config file from a kernel image
  4 #
  5 # This will only work when the kernel was compiled with CONFIG_IKCONFIG.
  6 #
  7 # The obscure use of the "tr" filter is to work around older versions of
  8 # "grep" that report the byte offset of the line instead of the pattern.
  9 #
 10 # (c) 2009,2010 Dick Streefland <dick@streefland.net>
 11 # Licensed under the terms of the GNU General Public License.
 12 # ----------------------------------------------------------------------
 13 
 14 cf1='IKCFG_ST\037\213\010'
 15 cf2='0123456789'
 16 
 17 dump_config()
 18 {
 19         if      pos=`tr "$cf1\n$cf2" "\n$cf2=" < "$1" | grep -abo "^$cf2"`
 20         then
 21                 pos=${pos%%:*}
 22                 tail -c+$(($pos+8)) "$1" | zcat > $tmp1 2> /dev/null
 23                 if      [ $? != 1 ]
 24                 then    # exit status must be 0 or 2 (trailing garbage warning)
 25                         cat $tmp1
 26                         exit 0
 27                 fi
 28         fi
 29 }
 30 
 31 try_decompress()
 32 {
 33         for     pos in `tr "$1\n$2" "\n$2=" < "$img" | grep -abo "^$2"`
 34         do
 35                 pos=${pos%%:*}
 36                 tail -c+$pos "$img" | $3 > $tmp2 2> /dev/null
 37                 dump_config $tmp2
 38         done
 39 }
 40 
 41 # Check invocation:
 42 me=${0##*/}
 43 img=$1
 44 if      [ $# -ne 1 -o ! -s "$img" ]
 45 then
 46         echo "Usage: $me <kernel-image>" >&2
 47         exit 2
 48 fi
 49 
 50 # Prepare temp files:
 51 tmp1=/tmp/ikconfig$$.1
 52 tmp2=/tmp/ikconfig$$.2
 53 trap "rm -f $tmp1 $tmp2" 0
 54 
 55 # Initial attempt for uncompressed images or objects:
 56 dump_config "$img"
 57 
 58 # That didn't work, so retry after decompression.
 59 try_decompress '\037\213\010' xy    gunzip
 60 try_decompress '\3757zXZ\000' abcde unxz
 61 try_decompress 'BZh'          xy    bunzip2
 62 try_decompress '\135\0\0\0'   xxx   unlzma
 63 try_decompress '\211\114\132' xy    'lzop -d'
 64 try_decompress '\002\041\114\030' xyy 'lz4 -d -l'
 65 
 66 # Bail out:
 67 echo "$me: Cannot find kernel config." >&2
 68 exit 1

This page was automatically generated by LXR 0.3.1 (source).  •  Linux is a registered trademark of Linus Torvalds  •  Contact us